/**********************************************************
　　製作者　　アドウィン
　　解　説　　「A」の点灯 – プログラム例２
**********************************************************/
#include <Arduino.h> // Arduino.h の読み込み

// ドットマトリクスLEDアノード側ピンの配列
int ledAnodePins[8] = {0, 2, 4, 5, 16, 17, 18, 19};
// ドットマトリクスLEDカソード側ピンの配列
int ledCathodePins[8] = {21, 22, 23, 25, 26, 27, 32, 33};
// 文字Aの点灯パターン
int ledPatternA[8][8] = {
    {LOW, LOW, LOW, LOW, LOW, LOW, LOW, LOW},
    {LOW, LOW, LOW, HIGH, LOW, LOW, LOW, LOW},
    {LOW, LOW, HIGH, LOW, HIGH, LOW, LOW, LOW},
    {LOW, HIGH, LOW, LOW, LOW, HIGH, LOW, LOW},
    {LOW, HIGH, LOW, LOW, LOW, HIGH, LOW, LOW},
    {LOW, HIGH, HIGH, HIGH, HIGH, HIGH, LOW, LOW},
    {LOW, HIGH, LOW, LOW, LOW, HIGH, LOW, LOW},
    {LOW, HIGH, LOW, LOW, LOW, HIGH, LOW, LOW},
};

/*
 * setup 関数
 */
void setup() {
  /* ここにプログラムの最初に1回だけ実行したい処理を上から順に記述していきます */

  // シリアル通信を115200bpsで開始
  Serial.begin(115200);

  Serial.println("初期設定の開始");

  // 各アノード・カソード端子の設定
  for (int i = 0; i < 8; i++) {

    // 入出力設定
    pinMode(ledAnodePins[i], OUTPUT);
    pinMode(ledCathodePins[i], OUTPUT);

    // 出力レベル設定（全消灯）
    digitalWrite(ledAnodePins[i], LOW);
    digitalWrite(ledCathodePins[i], HIGH);
  }

  Serial.println("初期設定の完了");
}

/*
 * loop 関数
 */
void loop() {
  /* ここにプログラム中で繰り返し実行したい処理を上から順に記述していきます */

  for (int i = 0; i < 8; i++) {
    // i行目の列の点灯設定
    for (int j = 0; j < 8; j++) {
      // i行目のj列目の点灯設定
      digitalWrite(ledAnodePins[j], ledPatternA[i][j]);
    }
    // i行目を点灯
    digitalWrite(ledCathodePins[i], LOW);
    // 時間待ち
    delay(1);
    // i行目を消灯
    digitalWrite(ledCathodePins[i], HIGH);
  }
}