/**********************************************************
　　製作者　　アドウィン
　　解　説　　論理演算子を用いたプログラム例
**********************************************************/
#include <Arduino.h>      // Arduino.h の読み込み
#include "dotmatrixled.h" // dotmatrixled.h の読み込み

// SW1用のピンの設定
int sw1 = 32;
// SW2用のピンの設定
int sw2 = 33;

/*
 * setup 関数
 */
void setup() {
  /* ここにプログラムの最初に1回だけ実行したい処理を上から順に記述していきます */

  // シリアル通信を115200bpsで開始
  Serial.begin(115200);

  Serial.println("初期設定の開始");

  // ドットマトリクスLED初期設定
  initLed();

  // SW1の初期設定
  pinMode(sw1, INPUT_PULLUP);
  // SW2の初期設定
  pinMode(sw2, INPUT_PULLUP);

  Serial.println("初期設定の完了");
}

/*
 * loop 関数
 */
void loop() {
  /* ここにプログラム中で繰り返し実行したい処理を上から順に記述していきます */

  // SW1ピンの電圧レベルをシリアルで出力
  Serial.println(digitalRead(sw1));

  // SW1 が ON かつ SW2 が OFF ならば、右上点灯
  if (digitalRead(sw1) == 0 && digitalRead(sw2) != 0) {
    setLed(0b00000001, 0b00000001);
  }
  // SW1 が OFF かつ SW2 が ON ならば、右下点灯
  else if (digitalRead(sw1) != 0 && digitalRead(sw2) == 0) {
    setLed(0b00000001, 0b10000000);
  }
  // SW1 が ON かつ SW2 が ON ならば、全点灯
  else if (digitalRead(sw1) == 0 && digitalRead(sw2) == 0) {
    setLed(0xFF, 0xFF);
  }
  // その他ならば、全消灯
  else {
    setLed(0, 0);
  }

  delay(1); // 時間待ち
}