/**********************************************************
　　製作者　　アドウィン
　　解　説　　チャタリング対策のプログラム例
**********************************************************/
#include <Arduino.h>      // Arduino.h の読み込み
#include "dotmatrixled.h" // dotmatrixled.h の読み込み
#include "switch.h"       // switch.h の読み込み

// 表示するドットマトリクスLEDの行
int indexRow = 0;

/*
 * setup 関数
 */
void setup() {
  /* ここにプログラムの最初に1回だけ実行したい処理を上から順に記述していきます */

  // シリアル通信を115200bpsで開始
  Serial.begin(115200);

  Serial.println("初期設定の開始");

  // ドットマトリクスLED初期設定
  initLed();
  // スイッチの初期設定
  initSwitch();

  // 1行目を点灯
  setLed(0b11111111, 0b00000001);

  Serial.println("初期設定の完了");
}

/*
 * loop 関数
 */
void loop() {
  /* ここにプログラム中で繰り返し実行したい処理を上から順に記述していきます */

  // SW1 を押して離すと点灯行が１行下がる
  if (SW1_ON) { // SW1 が ON

    // SW1がOFFになるまで待つ
    delay(10); // チャタリング対策　SW ON 時
    while (SW1_ON) delay(1); // SW1 が ON の間ループ
    delay(10); // チャタリング対策　SW OFF 時

    // LEDの点灯行を1行移動させる
    indexRow++;                                 // 点灯行の変更
    if (indexRow > 7) indexRow = 0;             // 点灯が一番下まできたら戻す
    setLed(0b11111111, 0b00000001 << indexRow); // indexRow行目を点灯
  }

  delay(1); // 時間待ち
}