/**********************************************************
　　製作者　　アドウィン
　　解　説　　ステッピングモータの回転 – プログラム例
**********************************************************/
#include <Arduino.h> // Arduino.h の読み込み

// ステッピングモータの動作ピン
int smPins[4] = {2, 5, 16, 17};
// ステッピングモータのパルスパターン
int smPattern[4] = {0b0001, 0b0010, 0b0100, 0b1000};
// ステッピングモータのパルス数
int smPulse = 0;

/*
 * setup 関数
 */
void setup() {
  /* ここにプログラムの最初に1回だけ実行したい処理を上から順に記述していきます */

  // シリアル通信を115200bpsで開始
  Serial.begin(115200);

  Serial.println("初期設定の開始");

  // ステッピングモータの動作ピンの初期設定
  for (int i = 0; i < 4; i++) {
    // 出力ピンに設定
    pinMode(smPins[i], OUTPUT);
    // Lレベルに設定
    digitalWrite(smPins[i], LOW);
  }

  Serial.println("初期設定の完了");
}

/*
 * loop 関数
 */
void loop() {
  /* ここにプログラム中で繰り返し実行したい処理を上から順に記述していきます */

  // パルス数が48未満（1回転未満）の時
  if (smPulse < 48) {
    // パルスパターンの取得
    int pattern = smPattern[smPulse % 4];
    // 各ピンへのパルスパターンの適用
    for (int i = 0; i < 4; i++) {
      digitalWrite(smPins[i], (pattern >> i) & 1);
    }
    // パルス数を 1 増やす
    smPulse++;
  }
  // 脱調防止のための時間待ち
  delay(10);
}