/**********************************************************
　　製作者　　アドウィン
　　解　説　　パルスカウンタ – ライブラリ化
**********************************************************/
#include <Arduino.h>       // Arduino.h の読み込み
#include "char8x8.h"       // char8x8.h の読み込み
#include "dotmatrixled.h"  // dotmatrixled.h の読み込み
#include "rotaryencoder.h" // rotaryencoder.h の読み込み

// ロータリエンコーダ用のピン
int encAPin = 26;
int encBPin = 27;

/*
 * setup 関数
 */
void setup() {
  /* ここにプログラムの最初に1回だけ実行したい処理を上から順に記述していきます */

  // シリアル通信を115200bpsで開始
  Serial.begin(115200);

  Serial.println("初期設定の開始");

  // ドットマトリクスLED初期設定
  initLed();

  // ロータリエンコーダの初期設定
  int multi = 4; // 逓倍の設定
  initEnc(encAPin, encBPin, multi);

  Serial.println("初期設定の完了");
}

/*
 * loop 関数
 */
void loop() {
  /* ここにプログラム中で繰り返し実行したい処理を上から順に記述していきます */

  // カウント数の取得
  int16_t count = getEncCount();

  // シリアルモニタに出力
  Serial.printf(" φ A: %d, φ B %d, カウント数 : %d\n",
  digitalRead(encAPin), digitalRead(encBPin), count);

  // ドットマトリクス LED の設定
  setLed(0xFF, ledCathodePattern[count & 0b111]);

  delay(1); // 時間待ち
}